# -*- coding: utf-8 -*-
"""
/***************************************************************************
 AddressSearchDockWidget
                                 A QGIS plugin
 Plugin enables to search Estonian official addresses and cadastral units.
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                             -------------------
        begin                : 2022-12-14
        git sha              : $Format:%H$
        copyright            : (C) 2022 by Estonian Land Board
        email                : maaamet@maaamet.ee
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""

import os

from qgis.PyQt import QtGui, QtWidgets, uic
from qgis.PyQt.QtCore import pyqtSignal

FORM_CLASS, _ = uic.loadUiType(os.path.join(
    os.path.dirname(__file__), 'address_search_settings.ui'))


class AddressSearchWidgetSettings(QtWidgets.QDockWidget, FORM_CLASS):

    closingPlugin = pyqtSignal()
    closing_spontaneous = pyqtSignal()

    def __init__(self, parent=None):
        """Constructor."""
        super(AddressSearchWidgetSettings, self).__init__(parent)
        # Set up the user interface from Designer.
        # After setupUI you can access any designer object by doing
        # self.<objectname>, and you can use autoconnect slots - see
        # http://doc.qt.io/qt-5/designer-using-a-ui-file.html
        # #widgets-and-dialogs-with-auto-connect
        self.setupUi(self)

    def closeEvent(self, event):
        if event.spontaneous():
            self.closing_spontaneous.emit()
        self.closingPlugin.emit()
        event.accept()
